#ifndef DENSITY_CLUSTERER_H
#define DENSITY_CLUSTERER_H

#include <pthread.h>

#include <math.h>
#include "config.h"
#include "transform3d.h"
#include "distance_tree.h"

typedef struct {
	int start;
	int n;

	float threshold;

	DistanceTree* tree;

	Transform3D* candidates;
	int candidates_size;

	float* densities;

} DCArgs;

Transform3D density_clusterer_get_best_candidate(Transform3D* candidates, int candidates_size);
void density_clusterer_init(float _spread, float _radius);

#endif
