#ifndef HASHTABLE_H
#define HASHTABLE_H

#define HASH_ADDED_NEW 1
#define HASH_ADDED_EXISTING 0

#define HASH_NO_DATA 0
#define HASH_DATA 1

#include "point3d.h"

typedef struct {
	int c1, c2, c3;
} Tuple;

typedef struct {
	char* data;
	Tuple* voxels;
	int size;
	float scale;
} HashTable;

HashTable* create_hashtable(int size, float delta);

int hashtable_contains(HashTable* table, Point3D point);
int hashtable_add(HashTable* table, Point3D point);

void free_hashtable(HashTable** table);

#endif
