#ifndef MATH_UTILS_H
#define MATH_UTILS_H

#include <math.h>
#include "point3d.h"
#include "matrix3x3.h"

#define EPSILON 1E-9
#define MAX_ITERATIONS 50

// #define POINTS_ADD_REF(Z, X) Z.x += X.x; Z.y += X.y; Z.z += X.z;
// #define POINTS_ADD(Z, X, Y) Z.x = X.x + Y.x; Z.y = X.y + Y.y; Z.z = X.z + Y.z;
// 
// #define POINTS_SUB_REF(Z, X) Z.x -= X.x; Z.y -= X.y; Z.z -= X.z;
// #define POINTS_SUB(Z, X, Y) Z.x = X.x - Y.x; Z.y = X.y - Y.y; Z.z = X.z - Y.z;
// 
// #define POINTS_CROSSPRODUCT(Z, X, Y) Z.x = X.y * Y.z - Y.y * X.z; Z.y = X.z * Y.x - Y.z * X.x; Z.z = X.x * Y.y - Y.x * X.y;
// 
// #define POINT_ABS(X) sqrt(X.x * X.x + X.y * X.y + X.z * X.z);
// 
// #define POINT_SCALE(X, S) X.x *= S; X.y *= S; X.z *= S;
// 
// #define POINTS_DISTANCE(X, Y) sqrt((X.x - Y.x) * (X.x - Y.x) + (X.y - Y.y) * (X.y - Y.y) + (X.z - Y.z) * (X.z - Y.z));

/* Computes eigenvectors of matrix 'm' and stores them in
 * matrix 'v'
 * 
 * m: input matrix from which eigenvectors are computed
 * v: output matrix used to store eigenvectors 
 *
 * returns: EXIT_FAILURE - fail, EXIT_SUCCESS - success 
 * (computation can fail due to too many iterations, defined by MAX_ITERATIONS) */
int evd(Matrix3x3* m, Matrix3x3* v);

#endif
