#ifndef NEIGHBOURS_CACHE_H
#define NEIGHBOURS_CACHE_H

#include "corner_table.h"

typedef struct {
	CornerTable* corner_table;

	/* For index 'i' data contains array of neighbours of vertex 'i'*/
	int** data;
	/* For index 'i' contains size of array data[i] */
	int* data_sizes;

	int size;
} NeighboursCache;

NeighboursCache* neighbours_cache_create(int size, CornerTable* ct);
int* neighbours_cache_get(const NeighboursCache* cache, int index, int* result_length);
void neighbours_cache_free(NeighboursCache** cache);

#endif
