#ifndef POINT_RECORD_H
#define POINT_RECORD_H

#include <stdio.h>

#include "point3d.h"

/* Data structure encapsulating point and its curvatures */
typedef struct {

	/* Principal curvatures */
	float k1, k2;

	/* Principal curvature direction */
	Point3D curvature_direction;

	Point3D normal, point;

} PointRecord;

PointRecord point_record_create(float k1, float k2, Point3D curvature_direction, Point3D normal, Point3D point);
float point_record_distance_squared(PointRecord r1, PointRecord r2);
void point_record_print(PointRecord r);

#endif
