
#include "neighbours_list.h"

Neighbours* neighbours_create() {
	Neighbours* n = malloc(sizeof(Neighbours));

	n->size = 0;
	n->capacity = INITIAL_CAPACITY;
	n->neighbours = malloc(sizeof(int) * INITIAL_CAPACITY);

	return n;
}

void neighbours_add(Neighbours* n, int element) {
	if(n->size >= n->capacity) {
		n->capacity *= 2;
		n->neighbours = realloc(n->neighbours, sizeof(int) * n->capacity);
	}

	n->neighbours[n->size] = element;
	n->size += 1;
}

NeighboursList* neighbours_list_create(TriangleMesh* mesh) {
	NeighboursList* list = malloc(sizeof(NeighboursList));

	list->size = mesh->points_size;
	list->neighbours_list = malloc(sizeof(Neighbours*) * list->size);
	for(int i = 0; i < list->size; ++i) {
		list->neighbours_list[i] = neighbours_create();
	}

	for(int i = 0; i < mesh->triangles_size; ++i) {
		Triangle t = mesh->triangles[i];

		neighbours_add(list->neighbours_list[t.v1], t.v2);
		neighbours_add(list->neighbours_list[t.v1], t.v3);

		neighbours_add(list->neighbours_list[t.v2], t.v1);
		neighbours_add(list->neighbours_list[t.v2], t.v3);

		neighbours_add(list->neighbours_list[t.v3], t.v1);
		neighbours_add(list->neighbours_list[t.v3], t.v2);
	}

	return list;
}

Neighbours* neighbours_list_get_neighbours(NeighboursList* nlist, int vertex) {
	return nlist->neighbours_list[vertex];
}
