
#include "point_record.h"

PointRecord point_record_create(float k1, float k2, Point3D curvature_direction, Point3D normal, Point3D point) {
	PointRecord record;

	record.k1 = k1;
	record.k2 = k2;
	record.curvature_direction = curvature_direction;
	record.normal = normal;
	record.point = point;

	return record;
}

float point_record_distance_squared(PointRecord r1, PointRecord r2) {
	float dk1 = r1.k1 - r2.k1;
	float dk2 = r1.k2 - r2.k2;

	return dk1 * dk1 + dk2 * dk2;
}

void point_record_print(PointRecord r) {
	printf("%f %f\n", r.k1, r.k2);
}
