
#include "transform3d.h"

//Transform3D transform3d_init() {
//	Transform3D result = {0};
//	return result;
//}

void transform3d_print(Transform3D t) {
	printf("[ %.12f %.12f %.12f | %.12f ]\n", t.rotation[0], t.rotation[1], t.rotation[2], t.translation[0]);
	printf("[ %.12f %.12f %.12f | %.12f ]\n", t.rotation[3], t.rotation[4], t.rotation[5], t.translation[1]);
	printf("[ %.12f %.12f %.12f | %.12f ]\n", t.rotation[6], t.rotation[7], t.rotation[8], t.translation[2]);
}

//Transform3D transform3d_create(float* rotation, float* translation) {
//	Transform3D result;
//
//	memcpy(result.rotation, rotation, sizeof(float) * 9);
//	memcpy(result.translation, translation, sizeof(float) * 3);
//
//	return result;
//}

Transform3D transform3d_create_map(PointRecord source, PointRecord target, int swap) {
	Transform3D result;
	Point3D v1 = target.normal;
	Point3D v2 = target.curvature_direction;

	if(swap) {
		point_negative_ref(&v2);
	}

	Point3D v3 = POINTS_CROSSPRODUCT(v1, v2);

	Matrix3x3 rotation_t = matrix3x3_create();
	/* Put vectors v1, v2, v3 to matrix's COLUMNS */
	matrix3x3_put_to_column(&rotation_t, v1, 0);
	matrix3x3_put_to_column(&rotation_t, v2, 1);
	matrix3x3_put_to_column(&rotation_t, v3, 2);

	v1 = source.normal;
	v2 = source.curvature_direction;
	v3 = POINTS_CROSSPRODUCT(v1, v2);

	Matrix3x3 rotation_s = matrix3x3_create();
	/* Put vectors v1, v2, v3 to matrix's ROWs */
	matrix3x3_put_to_row(&rotation_s, v1, 0);
	matrix3x3_put_to_row(&rotation_s, v2, 1);
	matrix3x3_put_to_row(&rotation_s, v3, 2);

	memcpy(result.rotation, matrix3x3_matrices_multiplication(rotation_t, rotation_s).data, sizeof(float) * 9);

	Point3D temp = matrix3x3_vector_multiply_data(result.rotation, source.point);

	result.translation[0] = target.point.x - temp.x;
	result.translation[1] = target.point.y - temp.y;
	result.translation[2] = target.point.z - temp.z;
	
	return result;
}

//Point3D transform3d_transform_point(Transform3D t, Point3D p) {
//	float x = t.rotation[0] * p.x + t.rotation[1] * p.y + t.rotation[2] * p.z + t.translation[0];
//	float y = t.rotation[3] * p.x + t.rotation[4] * p.y + t.rotation[5] * p.z + t.translation[1];
//	float z = t.rotation[6] * p.x + t.rotation[7] * p.y + t.rotation[8] * p.z + t.translation[2];
//
//	return create_point3d(x, y, z);
//}
//
//void transform3d_transform_point_ref(Transform3D t, Point3D* p) {
//	float x = t.rotation[0] * p->x + t.rotation[1] * p->y + t.rotation[2] * p->z + t.translation[0];
//	float y = t.rotation[3] * p->x + t.rotation[4] * p->y + t.rotation[5] * p->z + t.translation[1];
//	float z = t.rotation[6] * p->x + t.rotation[7] * p->y + t.rotation[8] * p->z + t.translation[2];
//
//	p->x = x;
//	p->y = y;
//	p->z = z;
//}
//
//void transform3d_transform_point_ref_translate_first(Transform3D t, Point3D* p) {
//	/* FIRST translation */
//	float tx = p->x + t.translation[0];
//	float ty = p->y + t.translation[1];
//	float tz = p->z + t.translation[2];
//
//	/* then rotation */
//	float x = t.rotation[0] * tx + t.rotation[1] * ty + t.rotation[2] * tz;
//	float y = t.rotation[3] * tx + t.rotation[4] * ty + t.rotation[5] * tz;
//	float z = t.rotation[6] * tx + t.rotation[7] * ty + t.rotation[8] * tz;
//
//	p->x = x;
//	p->y = y;
//	p->z = z;
//}
//
//void transform3d_rotate_point_ref(Transform3D t, Point3D* p) {
//	float x = t.rotation[0] * p->x + t.rotation[1] * p->y + t.rotation[2] * p->z;
//	float y = t.rotation[3] * p->x + t.rotation[4] * p->y + t.rotation[5] * p->z;
//	float z = t.rotation[6] * p->x + t.rotation[7] * p->y + t.rotation[8] * p->z;
//
//	p->x = x;
//	p->y = y;
//	p->z = z;
//}
