
#include <stdlib.h>
#include "vector_int.h"

VectorInt* vector_int_create() {
	VectorInt* vector = malloc(sizeof(VectorInt));

	if(vector == NULL) {
		return NULL;
	}
	
	vector->data = malloc(sizeof(int) * VECTOR_INITIAL_SIZE);
	vector->size = 0;
	vector->_size = VECTOR_INITIAL_SIZE;

	return vector;
}

void vector_int_free(VectorInt** vector) {
	if(vector == NULL || *vector == NULL) {
		return;
	}

	if((*vector)->data != NULL) {
		free((*vector)->data);
	}

	free(*vector);
	*vector = NULL;
}

int vector_int_add(VectorInt* vector, int element) {
	if(vector->size >= vector->_size) {
		vector->_size *= 2;
		vector->data = realloc(vector->data, sizeof(int) * vector->_size);

		if(vector->data == NULL) {
			return 0;
		}
	}

	vector->data[vector->size] = element;
	vector->size += 1;
	return 1;
}
